rm(list=ls(all=TRUE)) 
setwd( "E:/STUDY/Research/Generalized quantile/FPCA_GQR/code_201107/simulation_2013/realdata/95") 
library(orthogonalsplinebasis)
library(expectreg)
library(sspline)
library(fpca)
library(Matrix)
library(far)

source("parameter2.r")
#source("simdata.r")
#source("sim_set2.r")
source("knots.r")
source("wls_fit.r")
source("indiv.r")
source("initial_value.r")
#source("theta_f.r")
#source("alpha_f.r")
source("iteration.r")
source("loss.r")
source("alpha_cv.r")
source("optimize.r")
source("weight.r")
source("plot.r")


#vola=volatility[-(1:6),(-1)]
#M<-dim(vola)[1]
#N<-dim(vola)[2]
#x<-seq(1/365,1,length.out=M) # generate x
#p=0.95   # calculated expectile
#itt=30
#max1=0.005
#log.lambda0=c(2,0.5) # initial value of lambda
#Lambda<-rep(0,3) ## to save the estimate
#dim(Lambda)<-c(1,3)
#k_fold<-5  # Q-folder CV
#mm<-N/k_fold
#MSE<-rep(0,4)
#dim(MSE)<-c(1,4)
#y=vola
lambda1<-exp(log.lambda0[1])
   lambda2<-exp(log.lambda0[2])
   indiv_y<-indiv(y,p,lambda2,M,N)
   y_hat11<-indiv_y[[1]]   
   #save(y_hat11,file=paste(".\\","sim",sim,"\\", "y_hat_indiv.RData",sep=""))
   weight<-weight.sigular(y,p,lambda2,M,N) # the weight from the individual estimation
   #for (g in 1:G){
   g=6
   initial.est<-initial(y_hat11,g,d,M,N,B)  
   theta_mu2<-initial.est[[1]]  
   hat_theta2<-initial.est[[2]] 
   hat_alpha2<-initial.est[[3]]  
   hat_alpha2<-as.matrix(hat_alpha2)
   hat_alpha<-hat_alpha2
   lambda_cv<-optim(log.lambda0,CV.fun,  g0=g,k_fold=k_fold,n=N,m0=M,y=y,x=x,pp=p,mm=mm,d=d,B=B,weight=weight,initial_est=initial.est,method="Nelder-Mead",control=list(maxit=100,reltol=0.05))
#,lower=c(4,1),upper=c(5.5,1.8)
   lambda<-lambda_cv$par
   #loss<-CV.fun(lambda,g,k_fold,N,M,y,x,p,mm,d,B,weight,initial.est)
   Lambda=c(lambda,loss)  
   save(Lambda, file="Lambda.RData")

   lambda21<-exp(lambda[2])
   indiv_y<-indiv(y,p,lambda21,M,N)
   y_hat11<-indiv_y[[1]]
   #save(y_hat11,file=paste(".\\","sim",sim,"\\", "y_hat11.RData",sep=""))  # individual  curve
   w1<-rep(0,M*N)
   dim(w1)<-c(M,N)
   mean_yhat1<-B%*%theta_mu2
   mean_yhat<-rep(mean_yhat1,N)
   dim(mean_yhat)<-c(M,N)
  y_hat1<-mean_yhat+B%*%hat_theta2%*%t(hat_alpha2)
  for (j in 1:N)
  w1[,j]= as.vector(ifelse(y[,j] > y_hat1[,j], p, 1-p))
  estimate.final<-estimate(y,w1,itt,max1,lambda,M,N,g,d,B,theta_mu2,hat_theta2,  hat_alpha2,hat_alpha)
  save(estimate.final, file= "estimate_final.RData")
  mu.final<-estimate.final[[1]]
  theta.f<-estimate.final[[2]]
  alpha.final<-estimate.final[[3]]
  expectile.final<-estimate.final[[4]]
  mean.final<-estimate.final[[5]]

  #plot.final(x,expectile.final,mean.final,M,N)
dev<-B%*%theta.f%*%t(alpha.final)
dev_up<-rep(0, M)
dev_down<-rep(0, M)

for(i in 1:M)
{dev_up[i]<-quantile(dev[i,],0.95)
dev_down[i]<-quantile(dev[i,],0.05)
}

pdf("individual_china53_95.pdf")
 matplot(x*365,expectile.final, type="l", lty=1, lwd=0.5,col="grey",cex.lab=1.5,  cex.axis=1.8, ylab="",ylim=range(expectile.final),main="95% expectile curves")
lines(x*365, mean.final, lwd=4, col=1)
lines(x*365,mean.final+dev_up, lty=2, lwd=4, col=2)
lines(x*365,mean.final+dev_down, lty=2, lwd=4, col=2)
dev.off()

pdf("individual_china53_952.pdf")
 matplot(x*365,expectile.final, type="l", lty=1, lwd=0.5,col="grey",cex.lab=1.5,  cex.axis=1.8, ylab="",ylim=range(expectile.final),main="95% expectile curves")
#lines(x*365, mean.final, lwd=4, col=1)
lines(x*365,mean.final+dev_up, lty=2, lwd=4, col=2)
lines(x*365,mean.final+dev_down, lty=2, lwd=4, col=2)
dev.off()
# plot the eigenfunctions
pdf("eigenfunction_china53_95.pdf")
f<-B%*%theta.f
#matplot(x*365,f,type="l",lty=1, lwd=3)
matplot(x*365,B%*%theta.f, type="l", lty=c(1,2,3,4,5,6),lwd=3, cex.lab=1.5, cex.axis=1.5,  xlab="", ylab="", main="Eigenfunctions for 95% expectile curves")
dev.off()

pdf("alpha_china53_95.pdf")
plot(alpha.final[,1], ylim=range(alpha.final), type="l", lwd=3, cex.lab=1.5, cex.axis=1.5,  ylab="alpha")
lines(alpha.final[,2], lwd=3, col=2)
lines(alpha.final[,3], lwd=3, col=3)
dev.off()


# scalar plot of pairs of function scores:
alpha1<-alpha.final[,1]
alpha2<-alpha.final[,2]
alpha3<-alpha.final[,3]

pdf("scatter_china53_95.pdf")
pairs(alpha.final)
dev.off()

diag(var(alpha.final))

