
rm(list=ls(all=TRUE))
setwd("E:/STUDY/Research/Generalized quantile/FPCA_GQR/code_201107/simulation_2013/setup1")  # set the work directory
library(orthogonalsplinebasis)
library(expectreg)
library(splines)
library(fpca)
library(Matrix)
library(far)

source("parameter1.r")
#source("simdata.r")
source("sim_set1.r")
source("knots.r")
source("wls_fit.r")
source("indiv.r")
source("initial_value.r")
#source("theta_f.r")
#source("alpha_f.r")
source("iteration.r")
source("loss.r")
source("alpha_cv.r")
source("optimize.r")
source("weight.r")
source("plot.r")
gg=rep(0, sim_n)
vvar=rep(0, sim_n*4)
dim(vvar)=c(sim_n,4)
for (sim in 4:sim_n){
set.seed(1000000000+sim)
dir.create(paste("sim",sim, sep=""))

data.sim<-y_sim(x,M,N,d1,d2,d3)
mu_x<-data.sim[[1]]
f1_x<-data.sim[[2]]
f2_x<-data.sim[[3]]
alpha1<-data.sim[[4]]
alpha2<-data.sim[[5]]
y<-data.sim[[6]]
##############################################################################
#### save all the initial values into file with path "\\sim~\\~.txt"
###############################################################################
#write.table(mu_x,paste(".\\","sim",sim,"\\", "mu.txt",sep=""))
#write.table(f1_x,paste(".\\","sim",sim,"\\", "f1.txt",sep=""))
#write.table(f2_x,paste(".\\","sim",sim,"\\", "f2.txt",sep=""))
#write.table(alpha1,paste(".\\","sim",sim,"\\", "alpha1.txt",sep=""))
#write.table(alpha2,paste(".\\","sim",sim,"\\", "alpha2.txt",sep=""))
#write.table(y,paste(".\\","sim",sim,"\\", "y.txt",sep=""))
save(mu_x,file=paste(".\\","sim",sim,"\\", "mu.RData",sep=""))
save(f1_x,file=paste(".\\","sim",sim,"\\", "f1.RData",sep=""))
save(f2_x,file=paste(".\\","sim",sim,"\\", "f2.RData",sep=""))
save(alpha1,file=paste(".\\","sim",sim,"\\", "alpha1.RData",sep=""))
save(alpha2,file=paste(".\\","sim",sim,"\\", "alpha2.RData",sep=""))
save(y,file=paste(".\\","sim",sim,"\\", "y.RData",sep=""))


   start<-Sys.time()
   lambda1<-exp(log.lambda0[1])
   lambda2<-exp(log.lambda0[2])
   indiv_y<-indiv(y,p,lambda2,M,N)
   y_hat11<-indiv_y[[1]]   
   #save(y_hat11,file=paste(".\\","sim",sim,"\\", "y_hat_indiv.RData",sep=""))
   weight<-weight.sigular(y,p,lambda2,M,N) # the weight from the individual estimation
   G=4
 Lambda=rep(0,G*2)
 dim(Lambda)=c(G,2)
   g=1
   var1=c(1000,1000,1000,0)
   initial.est<-initial(y_hat11,g,d,M,N,B)  
   theta_mu2<-initial.est[[1]]  
   hat_theta2<-initial.est[[2]] 
   hat_alpha2<-initial.est[[3]]  
   hat_alpha2<-as.matrix(hat_alpha2)
   hat_alpha<-hat_alpha2
   lambda_cv<-optim(log.lambda0,CV.fun, g0=g,k_fold=k_fold,n=N,m0=M,y=y,x=x,pp=p,mm=mm,d=d,B=B,weight=weight,initial_est=initial.est,method="Nelder-Mead",control=list(maxit=100,reltol=0.005))
   lambda<-lambda_cv$par
   #loss<-CV.fun(lambda,g,k_fold,N,M,y,x,p,mm,d,B,weight,initial.est)}
   #loss=loss[order(loss)[1]]
   #lambda=lambda[order(loss)[1]]
   #g=order(loss)[1]
   #Lambda[sim,]=c(g,lambda,loss)  
   #write.csv(Lambda,"lambda.csv")
   #save(Lambda,file=paste(".\\","sim",sim,"\\", "Lambda.RData",sep=""))
   #end<-Sys.time()
   lambda21<-exp(lambda[2])
   indiv_y<-indiv(y,p,lambda21,M,N)
   y_hat11<-indiv_y[[1]]
   save(y_hat11,file=paste(".\\","sim",sim,"\\", "y_hat11.RData",sep=""))
   w1<-rep(0,M*N)
   dim(w1)<-c(M,N)
   mean_yhat1<-B%*%theta_mu2
   mean_yhat<-rep(mean_yhat1,N)
   dim(mean_yhat)<-c(M,N)
   y_hat1<-mean_yhat+B%*%hat_theta2%*%t(hat_alpha2)
   for (j in 1:N)
   w1[,j]= as.vector(ifelse(y[,j] > y_hat1[,j], p, 1-p))
  estimate.final<-estimate(y,w1,itt,max1,lambda,M,N,g,d,B,theta_mu2,hat_theta2, hat_alpha2,hat_alpha)
  alpha.final<-estimate.final[[3]]
  var1[1:g]=diag(var(alpha.final))
  Lambda[1,]=lambda
   g=2
   while(g<=G)
   {initial.est<-initial(y_hat11,g,d,M,N,B)  
   theta_mu2<-initial.est[[1]]  
   hat_theta2<-initial.est[[2]] 
   hat_alpha2<-initial.est[[3]]  
   hat_alpha2<-as.matrix(hat_alpha2)
   hat_alpha<-hat_alpha2
   lambda_cv<-optim(log.lambda0,CV.fun, g0=g,k_fold=k_fold,n=N,m0=M,y=y,x=x,pp=p,mm=mm,d=d,B=B,weight=weight,initial_est=initial.est,method="Nelder-Mead",control=list(maxit=100,reltol=0.005))
   lambda<-lambda_cv$par
   Lambda[g,]=lambda
   #loss<-CV.fun(lambda,g,k_fold,N,M,y,x,p,mm,d,B,weight,initial.est)}
   #loss=loss[order(loss)[1]]
   #lambda=lambda[order(loss)[1]]
   #g=order(loss)[1]
   #Lambda[sim,]=c(g,lambda,loss)  
   #write.csv(Lambda,"lambda.csv")
   #save(Lambda,file=paste(".\\","sim",sim,"\\", "Lambda.RData",sep=""))
   #end<-Sys.time()
   lambda21<-exp(lambda[2])
   indiv_y<-indiv(y,p,lambda21,M,N)
   y_hat11<-indiv_y[[1]]
   save(y_hat11,file=paste(".\\","sim",sim,"\\", "y_hat11.RData",sep=""))
  w1<-rep(0,M*N)
  dim(w1)<-c(M,N)
  mean_yhat1<-B%*%theta_mu2
  mean_yhat<-rep(mean_yhat1,N)
  dim(mean_yhat)<-c(M,N)
  y_hat1<-mean_yhat+B%*%hat_theta2%*%t(hat_alpha2)
  for (j in 1:N)
  w1[,j]= as.vector(ifelse(y[,j] > y_hat1[,j], p, 1-p))
  estimate.final<-estimate(y,w1,itt,max1,lambda,M,N,g,d,B,theta_mu2,hat_theta2, hat_alpha2,hat_alpha)
  alpha.final<-estimate.final[[3]]
  var1[1:g]=diag(var(alpha.final))
 if(var1[g]>1/9*var1[g-1])
  {g=g+1}
 else break
  }
 vvar[sim,]=var1
 print(g-1)
 g=g-1
  initial.est<-initial(y_hat11,g,d,M,N,B)  
   theta_mu2<-initial.est[[1]]  
   hat_theta2<-initial.est[[2]] 
   hat_alpha2<-initial.est[[3]]  
   hat_alpha2<-as.matrix(hat_alpha2)
   hat_alpha<-hat_alpha2
   #lambda_cv<-optim(log.lambda0,CV.fun, g0=g,k_fold=k_fold,n=N,m0=M,y=y,x=x,pp=p,mm=mm,d=d,B=B,weight=weight,initial_est=initial.est,method="Nelder-Mead",control=list(maxit=100,reltol=0.005))
   #lambda<-lambda_cv$par
   lambda=Lambda[g,]
   #loss<-CV.fun(lambda,g,k_fold,N,M,y,x,p,mm,d,B,weight,initial.est)}
   #loss=loss[order(loss)[1]]
   #lambda=lambda[order(loss)[1]]
   #g=order(loss)[1]
   #Lambda[sim,]=c(g,lambda,loss)  
   #write.csv(Lambda,"lambda.csv")
   #save(Lambda,file=paste(".\\","sim",sim,"\\", "Lambda.RData",sep=""))
   #end<-Sys.time()
   lambda21<-exp(lambda[2])
   indiv_y<-indiv(y,p,lambda21,M,N)
   y_hat11<-indiv_y[[1]]
   save(y_hat11,file=paste(".\\","sim",sim,"\\", "y_hat11.RData",sep=""))
  w1<-rep(0,M*N)
  dim(w1)<-c(M,N)
  mean_yhat1<-B%*%theta_mu2
  mean_yhat<-rep(mean_yhat1,N)
  dim(mean_yhat)<-c(M,N)
  y_hat1<-mean_yhat+B%*%hat_theta2%*%t(hat_alpha2)
  for (j in 1:N)
  w1[,j]= as.vector(ifelse(y[,j] > y_hat1[,j], p, 1-p))
  estimate.final<-estimate(y,w1,itt,max1,lambda,M,N,g,d,B,theta_mu2,hat_theta2, hat_alpha2,hat_alpha)
 #estimate.final<-estimate(y,w1,itt,max1,lambda,M,N,g,d,B,theta_mu2,hat_theta2, hat_alpha2,hat_alpha)
  save(estimate.final,file=paste(".\\","sim",sim,"\\", "estimate_final.RData",sep=""))
  mu.final<-estimate.final[[1]]
  theta.f<-estimate.final[[2]]
  alpha.final<-estimate.final[[3]]
  expectile.final<-estimate.final[[4]]
  mean.final<-estimate.final[[5]]
  expectile_theo1<-rep(0, M*N)
  dim(expectile_theo1)<-c(M,N)
  for(i in 1:N)
  expectile_theo1[,i]<-mu_x+f1_x*alpha1[i]+f2_x*alpha2[i]+enorm(p,sd=d3)
  mse1<-1/(M*N)*sum((expectile.final-expectile_theo1)^2)
  
  mse2<-1/(M*N)*sum((y_hat11-expectile_theo1)^2)

  expectile_theo<-mu_x+enorm(p,sd=d3)

  mean_y_se<-rowMeans(y_hat11) # the pointwise mean of single curves by SE(2009)
  
  mse_mean1<-(1/M)*sum((expectile_theo-mean.final)^2)
  mse_mean2<-(1/M)*sum((expectile_theo-mean_y_se)^2)

 MSE[sim,]<-c(mse1,mse2,mse_mean1,mse_mean2)
 gg[sim]=g
 save(Lambda,file= "Lambda.RData")
 save(MSE,file="MSE.RData")
 pdf(file=paste(".\\","sim",sim,"\\", "plot_final.pdf",sep=""))
 plot.final(x,expectile.final,mean.final,M,N)
 dev.off()

 pdf(file=paste(".\\","sim",sim,"\\", "mean_final.pdf",sep=""))
 mean.indiv<-rowMeans(y_hat11)
 matplot(x*M,cbind(expectile_theo,mean.final,mean.indiv),type="l", lty=1:3, lwd=4)
 dev.off()
print(sim)}
write.csv(gg,"g.csv")
write.csv(MSE,"mse.csv")

   
