
# the weighted least square estimation
fitwls_single<-function (object, x, y, p, penalty = 0) 
{
    B <- evaluate(object, x)
    n<-length(y)
    w1 <- 0 * y + 0.5
    w<-diag(w1,n)
    ww<-sqrt(w)
    dw1 = 1
    it = 1
    while (dw1 != 0 && it < 50) {
    a1<-solve(crossprod(ww%*%B) + penalty * OuterProdSecondDerivative(object), 
        crossprod(w%*%B, y))
    z1 <- B %*% a1
    w01 <- w1
    w1 <- as.vector(ifelse(y > z1, p, 1 - p))    
    dw1 <- sum(w1 != w01, na.rm = TRUE)
    w<-diag(w1,n)
    ww<-sqrt(w)
    it = it + 1
    }  
    list(a = a1, weight = w1, fitted = z1)   
}
